vRP = Proxy.getInterface("vRP")
vRPserver = Tunnel.getInterface("vRP","vRP_trucker")
vRPtruckS = Tunnel.getInterface("vRP_trucker","vRP_trucker")
vRPtruckC = {}
Tunnel.bindInterface("vRP_trucker",vRPtruckC)
Proxy.addInterface("vRP_trucker",vRPtruckC)

RegisterFontFile('wmk')
local fontId = RegisterFontId('Freedom Font')

x, y, z = 19.862901687622,-2486.0725097656,6.0067825317383
loadingBay = {37.981456756592,-2460.1625976562,6.0018796920776}

theTrailer = nil
incircle = false
incircle2 = false
inJob = false
hasTruck = nil
trailerBlip = nil
jobBlip = nil
trucks = {}
trailers = {}
jobDetails = {}
lBay = nil
leftBay = true

CreateThread(function()
	vRPtruckS.getTrucks({}, function(truckz, trailerz)
		trucks = truckz
		trailers = trailerz
	end)
end)

function round(x)
	return x>=0 and math.floor(x+0.5) or math.ceil(x-0.5)
end

function vRPtruckC.getDeliveryDistance(theX, theY, theZ)
	return round(Vdist(x, y, z, theX, theY, theZ))
end

function vRPtruckC.saveDeliveryDetails(theJob)
	jobDetails = theJob
	inJob = true
end

function vRPtruckC.spawnTrailer(theBay, bayLoc)
	bayX, bayY, bayZ = bayLoc[1], bayLoc[2], bayLoc[3]
	local vehicle = GetHashKey(trailers[math.random(1, #trailers)])
    RequestModel(vehicle)

	while not HasModelLoaded(vehicle) do
		Wait(1)
	end
    theTrailer = CreateVehicle(vehicle, bayX, bayY, bayZ, 180.0, true, false)
    SetVehicleOnGroundProperly(theTrailer)
	SetEntityAsMissionEntity( theTrailer, true, true )
	trailerBlip = AddBlipForEntity(theTrailer)
	SetBlipSprite(trailerBlip, 479)
	SetBlipColour(trailerBlip, 4)
	lBay = theBay
	leftBay = false
end

Citizen.CreateThread(function()
	while true do
		Citizen.Wait(1)
		local pos = GetEntityCoords(GetPlayerPed(-1), true)
		if(theTrailer) and (leftBay == false)then
			local trailerCoords = GetEntityCoords(theTrailer)
			if(GetDistanceBetweenCoords(trailerCoords.x, trailerCoords.y, trailerCoords.z, loadingBay[1], loadingBay[2], loadingBay[3]) > 10)then
				leftBay = true
				vRPtruckS.updateBayStats({lBay, 1})
				lBay = nil		
			end
		end
		if(inJob == true) then
			if(theTrailer ~= nil)then
				if not (IsEntityDead(theTrailer)) then
					local ok = GetVehiclePedIsIn(GetPlayerPed(-1), false)
					local ok2, vtype, name = vRP.getNearestOwnedVehicle({7})
					if (ok) then
						isInVehicle = false
						for i, v in pairs(trucks) do
							if (GetHashKey(v) == GetEntityModel(ok)) and (ok2) and (IsEntityAttached(theTrailer)) then
								isInVehicle = true
								if(trailerBlip ~= nil)then
									RemoveBlip(trailerBlip)
									trailerBlip = nil
								end
								if (jobBlip == nil)then
									jobBlip = AddBlipForCoord(jobDetails[2], jobDetails[3], jobDetails[4])
									SetBlipRoute(jobBlip, true)
								end
							end
						end
					else
					drawText("~HUD_COLOUR_NET_PLAYER13~Ai nevoie de un tir si o remorca pentru a finaliza livrarea !", 0.5, 0.85, 0.4, 255, 255, 255)
					end
					if(isInVehicle == false)then
					drawText("~HUD_COLOUR_NET_PLAYER13~Ai nevoie de un tir si o remorca pentru a finaliza livrarea !", 0.5, 0.85, 0.4, 255, 255, 255)
					elseif(isInVehicle == true)then
						if not IsEntityAttached(theTrailer) then
							trailerBlip = AddBlipForEntity(theTrailer)
							SetBlipSprite(trailerBlip, 479)
							SetBlipColour(trailerBlip, 4)
							drawText("~HUD_COLOUR_NET_PLAYER13~Ai nevoie de un tir si o remorca pentru a finaliza livrarea !", 0.5, 0.85, 0.4, 255, 255, 255)
						else
							destinationType = jobDetails[5]
							destinationName = jobDetails[1]
							distanceLeft = tonumber(string.format("%0.4f", round(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, jobDetails[2], jobDetails[3], jobDetails[4]))))
							--trucker_drawTxt("Destinatie: ~HUD_COLOUR_NET_PLAYER13~"..destinationName,1,1,0.5,0.8,0.3,255,255,255,255)
							--trucker_drawTxt("Incarcatura: ~HUD_COLOUR_NET_PLAYER13~"..destinationType,1,1,0.5,0.82,0.3,255,255,255,255)
							--trucker_drawTxt("Distanta: ~HUD_COLOUR_NET_PLAYER13~"..(distanceLeft/1000).." ~HUD_COLOUR_NET_PLAYER13~KM ~w~| ~w~Viata Trailer: ~HUD_COLOUR_NET_PLAYER13~"..GetEntityHealth(theTrailer).."~o~HP",4,1,0.5,0.84,0.4,255,255,255,255)
							drawText("Destinatie: ~HUD_COLOUR_NET_PLAYER13~"..destinationName, 0.5, 0.80, 0.4, 255, 255, 255)
							drawText("Incarcatura: ~HUD_COLOUR_NET_PLAYER13~"..destinationType, 0.5, 0.82, 0.4, 255, 255, 255)
							drawText("Distanta: ~HUD_COLOUR_NET_PLAYER13~"..(distanceLeft/1000).." ~w~KM | Viata Remorca: ~r~"..GetEntityHealth(theTrailer).."~w~HP", 0.5, 0.84, 0.4, 255, 255, 255)
						end
					end
				else
					finishJob()
					vRP.notify({"Cursa a fost anulata!"})
					if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x, y, z) > 40.0)then
						vRPtruckS.payTrailerFine({})
					end
				end
			end
		end
	end
end)

function finishJob()
	hasTruck = nil
	inJob = false
	jobDetails = {}
	if(jobBlip ~= nil)then
		RemoveBlip(jobBlip)
		jobBlip = nil
	end
	if(trailerBlip ~= nil)then
		RemoveBlip(trailerBlip)
		trailerBlip = nil
	end
	if(theTrailer ~= nil)then
		Citizen.InvokeNative(0xEA386986E786A54F , Citizen.PointerValueIntInitialized(theTrailer))
		theTrailer = nil
	end
end

CreateThread(function()
	while true do
		Citizen.Wait(1)
		local pos = GetEntityCoords(GetPlayerPed(-1), true)
		if(inJob == true)then
			x3, y3, z3 = jobDetails[2], jobDetails[3], jobDetails[4]
			if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x3, y3, z3) < 40.0)then
				destinationName = jobDetails[1]
				--DrawText3D(x3, y3, z3+0.4, "~o~"..destinationName, 2.0, 1)
				DrawMarker(39, x3, y3, z3-0.5, 0, 0, 0, 0, 0, 0, 1.3, 1.3, 1.3, 0, 47, 92, 115, 0, 0, 0, true)
			end
			if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x3, y3, z3) < 3)then
				incircle2 = true
				if (incircle2 == true) then
					drawText("Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~]  ~w~pentru a lasa marfa la ~HUD_COLOUR_NET_PLAYER13~"..destinationName, 0.5, 0.96, 0.3, 255, 255, 255)
					if IsControlJustReleased(0,38)then
						vRPtruckS.finishTruckingDelivery({jobDetails[6]})
						finishJob()
					end
				end
			elseif(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x3, y3, z3) > 5)then
				incircle2 = false
			end
		end
		
		if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x, y, z) < 40.0)then
			DrawMarker(22, x, y, z, 0, 0, 0, 0, 0, 0, 0.301, 0.301, 0.3001, 47, 92, 115, 255, 0, 0, 0, 1)
			if(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x, y, z) < 5)then
				incircle = true
				if (incircle == true) then
					if(hasTruck == nil)then
						local ok, vtype, name = vRP.getNearestOwnedVehicle({7})
						if (ok) then
							for i, v in pairs(trucks) do
								if (v == name) then
									hasTruck = 1
								end
							end
						end
					end
					--if (hasTruck == 1) then
						if(inJob == false)then
							drawText("Apasa [ ~HUD_COLOUR_NET_PLAYER13~E ~w~]  ~w~pentru a vedea cursele disponibile", 0.5, 0.96, 0.5, 255, 255, 255)
						else
							drawText("~HUD_COLOUR_NET_PLAYER13~Deja ai o cursa activa !", 0.3, 0.85, 0.4, 255, 255, 255)
						end	
						if(IsControlJustReleased(1, 51)) and (inJob == false)then
							TriggerServerEvent('openTruckerJobs')
						end
					--else
					--	drawText("Ai nevoie de un ~o~tir personal ~w~pentru a lucra ca trisit !", 0.5, 0.85, 0.4, 255, 255, 255)
					--end
				end
			elseif(GetDistanceBetweenCoords(pos.x, pos.y, pos.z, x, y, z) > 5)then
				incircle = false
				hasTruck = nil
			end
		end
	end
end)

